#!/usr/bin/env python

from distutils.core import setup

setup(name="smmapd",
      version="0.1",
      description="Framework for sendmail SocketMap handlers",
      long_description = """
A framework to build handlers for the sendmail 8.13 SocketMap,
together with an implementation of a sender-address verifier,
together we a sendmail m4 feature file""",
      author="Wolfgang Hottgenroth",
      author_email="woho@hottis.de",
      url="http://www.hottis.de/web/verifier/index.html",
      py_modules = [ 'SendmailSocketMapHandler', 'Cache', 'Logging', 'VerifierHandler' ],
      scripts = [ 'smmapd' ],
      data_files = [('config', ['smmapd.ini']),
                   ('cf/feature', ['verifysender.m4'])]
     )
